/*
*  File creategc.c
*  creates graphic context to draw or write in window
*
*  M.Bos - PA0MBO
*  Date May 5th 22006
*
*/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xproto.h>
#include <stdio.h>


/*  definition of own gc-creation routine */
 
GC
create_gc(Display* display, Window win, int reverse_video)
{
  GC gc;				/* handle of newly created GC.  */
  unsigned long valuemask = 0;		/* which values in 'values' to  */
					/* check when creating the GC.  */
  XGCValues values;			/* initial values for the GC.   */
  unsigned int line_width = 2;		/* line width for the GC.       */
  int line_style = LineSolid;		/* style for lines drawing and  */
  int cap_style = CapButt;		/* style of the line's edje and */
  int join_style = JoinBevel;		/*  joined lines.		*/
  /* int screen_num = DefaultScreen(display); */

  gc = XCreateGC(display, win, valuemask, &values);
  if (gc == NULL) {
	fprintf(stderr, "XCreateGC: \n");
  }

  /* allocate foreground and background colors for this GC. */
  if (reverse_video) {
    XSetForeground(display, gc, 257);  /* white in cmap_waterfall */
    XSetBackground(display, gc, 256);  /* black in cmap */
  }
  else {
    XSetForeground(display, gc, 256);
    XSetBackground(display, gc, 257);
  }

  /* define the style of lines that will be drawn using this GC. */
  XSetLineAttributes(display, gc,
                     line_width, line_style, cap_style, join_style);

  /* define the fill style for the GC. to be 'solid filling'. */
  XSetFillStyle(display, gc, FillSolid);

  return gc;
}

