
/*  
*  File dispfac.c
*
* M.Bos - PA0MBO
*
*  Date Feb 21st 2009
*/

/*************************************************************************
*
*                           PA0MBO
*
*    COPYRIGHT (C)  2009  M.Bos 
*
*    This file is part of the distribution package RXAMADRM
*
*    This package is free software and you can redistribute is
*    and/or modify it under the terms of the GNU General Public License
*
*    More details can be found in the accompanying file COPYING
*************************************************************************/


#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xproto.h>
#include <X11/keysym.h>
#include <stdio.h>
#include <stdlib.h>		/* getenv(), etc. */
#include <unistd.h>		/* sleep(), etc.  */
#include <math.h>
#include <signal.h>
void drawblock(int, int, Display *, GC, Window);


#define MAXXY 1.5
void
dispfac(float *fac_cells, int count, Display * display, GC theGC,
	Window mywin)
{
  int wheight, wwidth, i;

  XWindowAttributes xwa;
  int xpos, ypos, xcenter, ycenter;

  if (XGetWindowAttributes(display, mywin, &xwa) == 0)

    {
      printf("error getting attributes of mywin\n");
      exit(EXIT_FAILURE);
    }


/*    printf("dispfac count is %d\n", count);   */
  wheight = xwa.height;
  wwidth = xwa.width;
  xcenter = wwidth / 2;
  ycenter = wheight / 2;
  for (i = 0; i < count; i++)

    {
      xpos = (int) ((fac_cells[i * 2] / (2.0 * MAXXY)) * wwidth) + xcenter;
      ypos =
	(int) ((fac_cells[i * 2 + 1] / (2.0 * MAXXY)) * wheight) + ycenter;
      drawblock(xpos, ypos, display, theGC, mywin);
}}
