/*
*     File drmtst.c
*     
*     test program to drive subroutines used
*     in drm receiver
*
*     PA0MBO  - M.BOS
*     Date May 8th 2012
*
*/

/*************************************************************************
*
*                           PA0MBO
*
*    COPYRIGHT (C)  2012  M.Bos 
*
*    This file is part of the distribution package RXAMADRM
*
*    This package is free software and you can redistribute is
*    and/or modify it under the terms of the GNU General Public License
*
*    More details can be found in the accompanying file COPYING
*************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "drm.h"
#include "drmproto.h"
#include "drmdefs.h"


int main(int argc, char *argv[])
{
  int i, n;
  int im;
  float rRation = 1.0;
  float resamp_signal[2 * BUFSIZE];
  FILE *fplowpass;
  int resread;

  if (  ( fplowpass = fopen("hilbifilt.dat", "r"))==NULL)
  {
       printf("Cannot open hilbifilt.dat \n");
       exit(1);
  }
   

  for (i=0; i < LP_LENGTH  ; i++)
  {
      resread =  fscanf(fplowpass, "%g", &HilbIfilt[i]);
  }
  if (resread != 1 )
  {
     printf("failed to read inphasefilter data \n");
     exit(1);
  }

  if (  ( fplowpass = fopen("hilbqfilt.dat", "r"))==NULL)
  {
       printf("Cannot open hilbqfilt.dat \n");
       exit(1);
  }

  for (i=0; i < LP_LENGTH  ; i++)
  {
      resread =  fscanf(fplowpass, "%g", &HilbQfilt[i]);
  }
  if (resread != 1 )
  {
     printf("failed to read Quad filter data \n");
     exit(1);
  }



  /* init stereorec filters and filterstates */
  for (i=0 ; i < LP_LENGTH; i++)
  {
   ZifiltI[i]=0.0;
   ZifiltQ[i]=0.0;
  }
  n = BUFSIZE;

  /* initialisations */
  init_waterfall();                  /* init the waterfall window */

  init_audio();
  (void) demodulate(NULL, n, 1);	/* init static vars in demodulate */
  getmode(NULL, n / 4, NULL, 1);

/*     getofdm(NULL, 0.0, 0.0, 0.0, 320, 288, NULL, NULL, 1, NULL); 
     getofdmsync(NULL, 320, 288 , NULL, 200, 0,  NULL,
                 NULL, 1);  */
  rRation = 1.000;
  samplerate_offset_estimation = 0.0;
  im = resample(acq_signal, resamp_signal, rRation, n, 1);
  runstate = -2;		/* POWER_ON */
  channel_decoding();
  source_decoding();
  runstate = -1;		/* INIT */
  channel_decoding();
  source_decoding();
  runstate = 0;			/* FIRSTRUN */
  source_decoding();
  runstate = 1;			/* NORMAL RUN */
  i = 0;
  while (1 == 1)

    {
      if ((inpbufwidx == 0) && (input_samples_buffer_request > 0)) 
      { 
	n = stereorec(input_samples_buffer_request, bufaucnt);
      }
      else
	{
	  n = input_samples_buffer_request;
	  printf("else clause input_samples_buffer_request is %d inpbufwidx %d\n", n, inpbufwidx);
	}
      rRation = (float) (1.0 / (1.0 + samplerate_offset_estimation));
      im = resample(acq_signal, resamp_signal, rRation, n, 0);
      /* printf(" im = %d runstate %d\n", im, runstate); */
      (void) demodulate(resamp_signal, im, 0);
      channel_decoding();
      i++;
      source_decoding();
    } return (0);
}

