/*
*
*  File initwfall.c
*  initializes waterfall window
*  for drmtst program
*
*  Author M.Bos - PA0MBO
*  Date April 16th 2012
*/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xproto.h>
#include <stdio.h>
#include <stdlib.h>		/* getenv(), etc. */
#include <unistd.h>		/* sleep(), etc.  */
#include <string.h>

#define MAXINTENS  65535

extern Display *display;
extern Pixmap pmap_waterfall, pmap_tmp;
extern GC gc_waterfall;
extern Window win_waterfall; 
extern XVisualInfo vis_info_waterfall ;
extern int screen_num ;
extern Visual *theVisual_waterfall;
extern int vis_depth_waterfall, cmap_size_waterfall;
extern Colormap cmap_waterfall ;
extern Window theMain;
extern unsigned int npixels_waterfall;
extern unsigned long pixels_waterfall[300];
extern int width_waterfall, height_waterfall;
extern char *display_name;


GC create_gc(Display *, Window, int);

void
init_waterfall(void)
{
  XColor  color;
  unsigned short red, green, blue ;
  int i,j; 
  XSetWindowAttributes xswa; 
  
 /* open connection with the X server. */
  display = XOpenDisplay(display_name);
  if (display == NULL) {
    fprintf(stderr, "%s: cannot connect to X server '%s'\n",
            "drmtst", display_name);
    exit(1);
  }

  /* get the geometry of the default screen for our display. */
  screen_num = DefaultScreen(display);
  theMain = RootWindow(display, screen_num);

/*determine the right visual 

  if (!XMatchVisualInfo(display, screen_num, 24, DirectColor, &vis_info_waterfall))
  {
     printf("No suitable visual found \n");
     exit(1);
  } */


  theVisual_waterfall= DefaultVisual(display, screen_num) ;
  vis_depth_waterfall= DefaultDepth(display, screen_num) ;


  cmap_size_waterfall= vis_info_waterfall.colormap_size;

   cmap_waterfall = DefaultColormap(display, screen_num); 
  if (cmap_waterfall==0)
  {
     printf("create colormap failed\n");
     exit(1);
  }


  /* fill the set of colors we will want to use for the drawing. */

  for (i=1; i< 255 ; i++)
  {
    blue = (float)MAXINTENS *(1.0- (float)i/256.0);
    red= (((float)i)/256.0)*(float)MAXINTENS ;
    green=red ;
 
   color.red=red ;
   color.blue=blue;
   color.green=green;
   color.flags = DoRed | DoGreen | DoBlue ;
   XAllocColor(display, cmap_waterfall, &color);
   pixels_waterfall[i]= color.pixel;
  }

  color.red=MAXINTENS;
  color.blue=MAXINTENS;
  color.green=MAXINTENS;     
  color.flags = DoRed | DoGreen | DoBlue;
  XAllocColor(display, cmap_waterfall, &color); 
  pixels_waterfall[255] = color.pixel; 
/*  xswa.colormap = cmap_waterfall; */
  xswa.colormap = DefaultColormap(display, screen_num);
/*  xswa.background_pixel =    pixels_waterfall[255] ; */
  xswa.border_pixel= BlackPixel(display, screen_num);;
    xswa.background_pixel= BlackPixel(display, screen_num);
/*    xswa.border_pixel = pixels_waterfall[0]; */



  pmap_waterfall = XCreatePixmap(display, theMain, width_waterfall,
                    height_waterfall, vis_depth_waterfall);
  pmap_tmp = XCreatePixmap(display, theMain, width_waterfall,
                   height_waterfall, vis_depth_waterfall); 
/*  win_waterfall = XCreateWindow(display, theMain, 50,50,
                   width_waterfall, 200, 20, vis_depth_waterfall,
                   InputOutput, theVisual_waterfall,
                   CWColormap |  CWBorderPixel | CWEventMask | CWBackPixel , &xswa); */
    win_waterfall = XCreateSimpleWindow(display, theMain, 50,50,
		     width_waterfall, height_waterfall, 20,pixels_waterfall[128],   BlackPixel(display, screen_num));

XSetStandardProperties(display, win_waterfall,
 "   RXAMADRM   -  PA0MBO", 
 "   RXAMADRM   -  PA0MBO" , None, NULL, 0, NULL);

  gc_waterfall = create_gc(display, win_waterfall, 0);
  /* now put frequency markers in top lines of window */
  for (i=0; i < 20 ; i++)
  {
     /* XSetForeground(display, gc_waterfall, BlackPixel(display, screen_num)); */
     XSetForeground(display, gc_waterfall, WhitePixel(display, screen_num));
     for (j=0; j < width_waterfall ; j++)
     {
          XDrawPoint(display, win_waterfall, gc_waterfall, j, i);
     }
     XSetForeground(display, gc_waterfall,WhitePixel(display, screen_num));
     XDrawPoint(display, win_waterfall, gc_waterfall, 50, i);
     XDrawPoint(display, win_waterfall, gc_waterfall, 51, i);
     XDrawPoint(display, win_waterfall, gc_waterfall, 125, i);
     XDrawPoint(display, win_waterfall, gc_waterfall, 126, i);
     XDrawPoint(display, win_waterfall, gc_waterfall, 200, i);
     XDrawPoint(display, win_waterfall, gc_waterfall, 201, i);
  }

  XMapWindow(display, win_waterfall);
  XSync(display, False);
}

