/*
*
*  File initwfall.c
*  initializes waterfall window
*  for drmtst program
*
*  Author M.Bos - PA0MBO
*  Date April 16th 2012
*/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xproto.h>
#include <stdio.h>
#include <stdlib.h>		/* getenv(), etc. */
#include <unistd.h>		/* sleep(), etc.  */
#include <string.h>

#define MAXINTENS 65535

extern Display *display;
extern Pixmap pmap_waterfall, pmap_tmp;
extern GC gc_waterfall;
extern Window win_waterfall; 
extern XVisualInfo vis_info_waterfall ;
extern int screen_num ;
extern Visual *theVisual_waterfall;
extern int vis_depth_waterfall, cmap_size_waterfall;
extern Colormap cmap_waterfall ;
extern Window theMain;
extern unsigned int npixels_waterfall;
extern unsigned long pixels_waterfall[300];
extern int width_waterfall;
extern char *display_name;


GC create_gc(Display *, Window, int);

void
init_waterfall(void)
{
  Bool contig=True ;
  unsigned long planes[2];      /* dummy */
  unsigned int nplanes=0 ;
  XColor  color;
  unsigned short red, green, blue ;
  int i; 
  XSetWindowAttributes xswa; 
  
 /* open connection with the X server. */
  display = XOpenDisplay(display_name);
  if (display == NULL) {
    fprintf(stderr, "%s: cannot connect to X server '%s'\n",
            "drmtst", display_name);
    exit(1);
  }

  /* get the geometry of the default screen for our display. */
  screen_num = DefaultScreen(display);
  theMain = RootWindow(display, screen_num);

/*determine the right visual */

  if (!XMatchVisualInfo(display, screen_num, 24, DirectColor, &vis_info_waterfall))
  {
     printf("No suitable visual found \n");
     exit(1);
  }

  theVisual_waterfall=vis_info_waterfall.visual ;
  vis_depth_waterfall=vis_info_waterfall.depth ;
  cmap_size_waterfall= vis_info_waterfall.colormap_size;
  
   
  printf("cmap size %d\n",  cmap_size_waterfall);  

  cmap_waterfall= XCreateColormap(display, theMain, theVisual_waterfall , AllocNone);
  /* cmap_waterfall = DefaultColormap(display, screen_num); */
  if (cmap_waterfall==0)
  {
     printf("create colormap failed\n");
     exit(1);
  }


  /* allocate color cells */
  npixels_waterfall= 256;
  nplanes=0;
  if (XAllocColorCells(display, cmap_waterfall, contig, planes, nplanes, pixels_waterfall,
             npixels_waterfall)==0)
  {
    printf("cannot alloc color cells \n");
    printf("contig %d nplanes %d npixels %d\n", contig, nplanes, npixels_waterfall);
    exit(1);
  }
  /* fill the set of colors we will want to use for the drawing. */

  for (i=0; i< 254 ; i++)
  {
    blue = (float)MAXINTENS *(1.0- (float)i/256.0);
    red= (((float)i)/256.0)*(float)MAXINTENS ;
    green=blue ;

 
   printf("i %d red %d blue %d green %d  \n",i,red,blue, green);   
   color.pixel=i;
   color.red=red ;
   color.blue=blue;
   color.green=green;
   color.flags = DoRed | DoGreen | DoBlue ;
/*    printf("before XStoreColor i=%d \n",i);   */
   XStoreColor(display, cmap_waterfall, &color);
  }
  /* some special colors for separators or borders and background */
  color.pixel= 254;
  color.red=0;
  color.blue=0;
  color.green=0;      /* black */
  color.flags = DoRed | DoGreen | DoBlue;
  XStoreColor(display, cmap_waterfall, &color); /* no 254 = black */

  color.pixel= 255;
  color.red=MAXINTENS;
  color.blue=MAXINTENS;
  color.green=MAXINTENS;      /* white */
  color.flags = DoRed | DoGreen | DoBlue;
  XStoreColor(display, cmap_waterfall, &color); /* no 255 = white */
 
  xswa.colormap = cmap_waterfall;
//  xswa.colormap = DefaultColormap(display, screen_num);
  xswa.background_pixel =40  ;
//  xswa.border_pixel= 255;
//    xswa.background_pixel= WhitePixel(display, screen_num);
    xswa.border_pixel = 0;



 
  win_waterfall = XCreateWindow(display, theMain, 50,50,
                   width_waterfall, 400, 20, vis_depth_waterfall,
                   InputOutput, theVisual_waterfall,
                   CWColormap |  CWBorderPixel | CWEventMask | CWBackPixel , &xswa);



/* debugging  
  for (i=0; i<256; i++)
  printf(" i %d pixel[i] %d \n", i, pixels_waterfall[i]);  */ 
 



  /* allocate a new GC (graphics context) for drawing in the window and for buttons */
  gc_waterfall = create_gc(display, win_waterfall, 0);

  XMapWindow(display, win_waterfall);
  XSync(display, False);
  printf("einde initwfal \n");
  sleep(10);
}

